package com.cku.core;

import java.sql.SQLException;

public class ExceptionFilter {
	public static int FindCode(Exception e) {
		if (e instanceof java.lang.IndexOutOfBoundsException) {
			return ZAErrorCode.ZA_ERC_INDEX_OUT_OF_RANGE;
		}

		if (e instanceof NullPointerException) {
			return ZAErrorCode.ZA_ERC_INVALID_POINTER;
		}

		if (e instanceof ZAException)
		{
			ZAException sre = (ZAException)e;
			return sre.get_code();
		}

		if (e instanceof SQLException)
		{
			return ZAErrorCode.ZA_ERC_SQL;
		}

		return ZAErrorCode.ZA_ERC_UNKNOWN;
	}
}
