package com.cku.core;

import java.util.List;
/**
 * 返回结果处理
 * @author lyy
 */

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.serializer.SerializerFeature;
public class ExecResultModel<T> {
	
	private Integer rc;
	private String msg;
	private List<T> items = null;
	private Long total = null;
	
	public ExecResultModel(){
		
	}

	public ExecResultModel(Integer rc, String msg, List<T> items) {
		this.rc = rc;
		this.msg = msg;
		this.items = items;
	}
	
	public ExecResultModel(Integer rc, String msg, List<T> items, Long total) {
		this.rc = rc;
		this.msg = msg;
		this.items = items;
		this.total = total;
	}
	
	public ExecResultModel(Integer rc, String msg) {
		this.rc = rc;
		this.msg = msg;
		this.items = null;
	}

	public Integer getrc() {
		return rc;
	}

	public void setrc(Integer rc) {
		this.rc = rc;
	}

	public String getmsg() {
		return msg;
	}

	public void setmsg(String msg) {
		this.msg = msg;
	}

	public List<T> getItems() {
		return items;
	}

	public void setItems(List<T> items) {
		this.items = items;
	}
	
	public Long getTotal() {
		return total;
	}

	public void setTotal(Long total) {
		this.total = total;
	}

	public String getToJson()
	{
		StringBuffer sb = new StringBuffer();
		sb.append("{");
		
		sb.append("\"rc\":");
		sb.append(rc + ",");
		
		sb.append("\"msg\":\"");
		sb.append(msg + "\",");
		
		sb.append("\"items\":[");
		
		if(items != null)
		{
			int len = items.size();
			int i = 1;
			for(T am : items)
			{
				String spe = (i == len) ? "" : ",";
				sb.append(JSON.toJSONString(am,SerializerFeature.WriteMapNullValue)+spe);
				i ++;
			}
		}
		
		sb.append("],");
		
		sb.append("\"total\":\"");
		sb.append(total + "\"");
		
		sb.append("}");
		
		return sb.toString();
	}

	public Integer getRc() {
		return rc;
	}

	public void setRc(Integer rc) {
		this.rc = rc;
	}

	public String getMsg() {
		return msg;
	}

	public void setMsg(String msg) {
		this.msg = msg;
	}
	
	
	
}
